import java.util.*;
import java.text.*;

class Pessoa extends Usuario{
  // Atributos privados.
  public ArrayList <Relacao> relacionamentos;
  private ArrayList <Grupo> grupos;

  // Geters
  // Retorna a relacao que esta no indice ind dos relacionamentos do usuario
  public Relacao getRelacao(int ind){
    return(this.relacionamentos.get(ind));
  }

  // Retorna o indice da relacao relacaoProcurada que esta nos relacionamentos do usuario
  public int getIndiceRelacao(Relacao relacaoProcurada){
    return(this.relacionamentos.indexOf(relacaoProcurada));
  }

  // Retorna o grupo que esta no indice ind dos grupos do usuario
  public Grupo getGrupo(int ind){
    return(this.grupos.get(ind));
  }

  // Retorna o indice do grupo grupoProcurado que esta nos grupos do usuario
  public int getIndiceGrupo(Grupo grupoProcurado){
    return(this.grupos.indexOf(grupoProcurado));
  }

  // Metodos
  public void adicionaPessoa(Pessoa novoRelacionado, String tipo, int afinidade){
    int i;

    for(i = 0; i < this.relacionamentos.size() - 1; i++){
      if(this.relacionamentos.get(i).getRelacionado() == novoRelacionado){
        this.relacionamentos.get(i).setFim();
      }
    }
    Relacao novaRelacao = new Relacao(novoRelacionado, tipo, afinidade);
    this.relacionamentos.add(novaRelacao);
  }

  public void entraGrupo(Grupo grupo){
    grupo.adicionaMembro(this);
    this.grupos.add(grupo);
  }

  public void saiGrupo(Grupo grupo){
    grupo.removeMembro(this);
    this.grupos.remove(grupo);
  }

  // métodos
  public void publicaPensamento(String conteudo){
    int i;
    Relacao atual;
    String resultado;

    Pensamento novoPensamento = new Pensamento(conteudo, this);
    this.pensamentos.add(novoPensamento);
    // notifica observadores
    resultado = String.format("%s publicou: %s", this.nome, conteudo);
    this.publicacoes.add(resultado);
    // this.nome publicou "conteudo"
  }

  public void publicaComentario(String conteudo, Pensamento pensamento){
    int i;
    Relacao atual;
    String resultado;

    Comentario novoComentario = new Comentario(pensamento, conteudo, this);
    this.comentarios.add(novoComentario);
    // notifica observadores
    resultado = String.format("%s comentou: %s no pensamento %s de %s", this.nome, conteudo, pensamento.conteudo, pensamento.usuario.nome);
    this.publicacoes.add(resultado);
    // this.nome comentou "conteudo" no pensamento "pensamento.conteudo" de pensamento.usuario.nome
  }

  public void publicaLike(Pensamento pensamento){
    int i;
    Relacao atual;
    String resultado;

    Like novoLike = new Like(pensamento, this);
    this.likes.add(novoLike);
    // notifica observadores
    resultado = String.format("%s curtiu o pensamento %s de %s", this.nome, pensamento.conteudo, pensamento.usuario.nome);
    this.publicacoes.add(resultado);
    // this.nome curtiu o pensamento "pensamento.conteudo" de pensamento.usuario.nome
  }

  public void publicaDislike(Pensamento pensamento){
    int i;
    Relacao atual;
    String resultado;

    Dislike novoDislike = new Dislike(pensamento, this);
    this.dislikes.add(novoDislike);
    // notifica observadores
    resultado = String.format("%s nao curtiu o pensamento %s de %s", this.nome, pensamento.conteudo, pensamento.usuario.nome);
    this.publicacoes.add(resultado);
    // this.nome não curtiu o pensamento "pensamento.conteudo" de pensamento.usuario.nome
  }

  public void publicaTimeline (String mensagem) {
    System.out.printf("entrou no metodo publicaTimeline\n");
    this.timeline.add(mensagem);
  }

  public void mostraTimeline () {
    int i, j;

    System.out.printf("Timeline de %s: \n", this.nome);
    for (i = 0; i < relacionamentos.size(); i++) {
      for (j = 0; j < relacionamentos.get(i).relacionado.publicacoes.size(); j++) {
        System.out.printf("%s \n", relacionamentos.get(i).relacionado.publicacoes.get(j));
      }
    }
    for (i = 0; i < grupos.size(); i++) {
      for (j = 0; j < grupos.get(i).publicacoes.size(); j++) {
        System.out.printf("%s \n", grupos.get(i).publicacoes.get(j));
      }
    }
  }

  // Construtor
  public Pessoa(String novoNome, String novoLogin){
    this.relacionamentos = new ArrayList <Relacao>();
    this.grupos = new ArrayList <Grupo>();
    this.setNome(novoNome);
    this.setLogin(novoLogin);
    this.setDataCriacao();
    pensamentos = new ArrayList <Pensamento>();
    comentarios = new ArrayList <Comentario>();
    likes = new ArrayList <Like>();
    dislikes = new ArrayList <Dislike>();
    timeline = new ArrayList <String>();
    publicacoes = new ArrayList<String>();
  }
}
